import java.awt.*;
import java.applet.*;
import java.net.*;
import java.lang.*;
import java.io.*;
import java.awt.event.*;

// Naken Chat Applet Version 1.60 (May 1, 2006)
// Copyright 1998-2006 by Michael Kohn

// You may edit this source for your own personal needs.
// You may not distribute modifications or sell any part of
// this.  You may not take credit for writing this.

// If this license doesn't satisfy your needs, you can
// negotiate something with me.   Email:  mike@mikekohn.net
// for more info.

// Please read readme.txt file for copying/usage info

public class nakenchatapplet extends Applet implements Runnable,ActionListener,ItemListener
{
DisplayArea myDisplay;
TextArea myTextArea;
Thread myThread;
Socket mySocket;
InputStream myInputStream;
BufferedInputStream myBuffInput;
OutputStream myOutputStream;
Graphics gg;
TextField messageText,channelText,nameText;
int Online=0;
Choice chanChoice;
String YourName="";
int fontsize=13,allowanychannel=1;
Font myFont;
String font="monospaced";
byte namebar=1,rightbar=1,channelbar=1;
String host;
Panel NorthPanel=new Panel();
Panel EastPanel=new Panel();
Panel CenterPanel=new Panel();
String encodingString=null;
ButtonCanvas buttonCanvas;
List userList=null;
int loggedin=0;
Frame privateFrame;
Panel privatePanel,privateButtonPanel;
Label privateLabel;
TextField privateText;
Button privateCancelButton,privateSendButton;

  public void init()
  {
  Panel SouthPanel=new Panel();
  int r=0,eastitems;
  Label chanLabel;
  MediaTracker myTracker=new MediaTracker(this);
  int tracked=0;
  Color panelColor=null,panelforeColor=null;

// You may not change or remove the next 3 lines

    System.out.println("Naken Chat Applet version 1.60");
    System.out.println("Copyright 1998-2005 Michael Kohn");
    System.out.println("http://nakenchat.naken.cc/");

    setLayout(new BorderLayout());
    NorthPanel.setLayout(new FlowLayout(FlowLayout.LEFT));

    SouthPanel.setLayout(new BorderLayout());
    SouthPanel.add("West",new Label("Message:"));
    SouthPanel.add("Center",messageText=new TextField());

    if (getParameter("channelbox")!=null && !getParameter("channelbox").equals("0"))
    {
      NorthPanel.add(chanLabel=new Label("Channel:",Label.RIGHT));
      NorthPanel.add(chanChoice=new Choice());
      NorthPanel.add(channelText=new TextField("Main",14));
      chanChoice.addItem("---->");
      chanChoice.addItem("Main");
      r=1;
      while(getParameter("channel"+r)!=null)
      { chanChoice.add(getParameter("channel"+(r++))); }

      channelText.addActionListener(this);
      chanChoice.addItemListener(this);
    }

    if (getParameter("namebox")!=null && !getParameter("namebox").equals("0"))
    {
      NorthPanel.add(new Label("Name:",Label.RIGHT));
      NorthPanel.add(nameText=new TextField("",15));
      nameText.addActionListener(this);
    }

    CenterPanel.setLayout(new BorderLayout());
    CenterPanel.add("Center",myDisplay=new DisplayArea());

    if (getParameter("fgcolor")!=null)
    { myDisplay.fgColor=myDisplay.convColor(getParameter("fgcolor")); }
      //else
    //{ myDisplay.fgColor=Color.white; }

    if (myDisplay.fgColor==null) myDisplay.fgColor=Color.white;

    if (getParameter("bgcolor")!=null)
    { myDisplay.bgColor=myDisplay.convColor(getParameter("bgcolor")); }
   //   else
   // { myDisplay.bgColor=Color.black; }

    if (myDisplay.bgColor==null) myDisplay.bgColor=Color.black;

    if (getParameter("mscolor")!=null)
    { myDisplay.msColor=myDisplay.convColor(getParameter("mscolor")); }
   //   else
   // { myDisplay.msColor=new Color(100,255,100); }

    if (myDisplay.msColor==null) myDisplay.msColor=new Color(100,255,100);

    if (getParameter("privcolor")!=null)
    { myDisplay.privColor=myDisplay.convColor(getParameter("privcolor")); }
   //   else
   // { myDisplay.privColor=new Color(0,160,255); }

    if (myDisplay.privColor==null) myDisplay.privColor=new Color(0,160,255);

    if (getParameter("yellcolor")!=null)
    { myDisplay.yellColor=myDisplay.convColor(getParameter("yellcolor")); }
    //  else
    //{ myDisplay.yellColor=new Color(255,100,100); }

    if (myDisplay.yellColor==null) myDisplay.yellColor=new Color(255,100,100);

    if (getParameter("panelbackcolor")!=null)
    { panelColor=myDisplay.convColor(getParameter("panelbackcolor")); }
   //    else
    // { panelColor=Color.lightGray; }

    if (panelColor==null) panelColor=Color.lightGray;

    if (getParameter("panelforecolor")!=null)
    { panelforeColor=myDisplay.convColor(getParameter("panelforecolor")); }
    //   else
    // { panelforeColor=Color.black; }

    if (panelforeColor==null) panelforeColor=Color.black;

    NorthPanel.setBackground(panelColor);
    SouthPanel.setBackground(panelColor);
    EastPanel.setBackground(panelColor);
    CenterPanel.setBackground(panelColor);

    NorthPanel.setForeground(panelforeColor);
    SouthPanel.setForeground(panelforeColor);
    EastPanel.setForeground(panelforeColor);
    CenterPanel.setForeground(panelforeColor);

    if (getParameter("scrollbarcolor")!=null)
    { myDisplay.scrollbarColor=myDisplay.convColor(getParameter("scrollbarcolor")); }

    if (myDisplay.scrollbarColor==null) myDisplay.scrollbarColor=Color.lightGray;

    if (getParameter("rightbar")!=null)
    {
      if (getParameter("rightbar").equals("0")) rightbar=0;
    }

    eastitems=8;

    if (rightbar==1)
    {
      EastPanel.setLayout(null);
      buttonCanvas=new ButtonCanvas(myDisplay,this);
      buttonCanvas.whoImage=getImage(getDocumentBase(),getParameter("whoImage"));
      myTracker.addImage(buttonCanvas.whoImage,tracked++);
      buttonCanvas.whoImagedn=getImage(getDocumentBase(),getParameter("whoImagedn"));
      myTracker.addImage(buttonCanvas.whoImagedn,tracked++);

      buttonCanvas.channelImage=getImage(getDocumentBase(),getParameter("channelImage"));
      myTracker.addImage(buttonCanvas.channelImage,tracked++);
      buttonCanvas.channelImagedn=getImage(getDocumentBase(),getParameter("channelImagedn"));
      myTracker.addImage(buttonCanvas.channelImagedn,tracked++);

      buttonCanvas.helpImage=getImage(getDocumentBase(),getParameter("helpImage"));
      myTracker.addImage(buttonCanvas.helpImage,tracked++);
      buttonCanvas.helpImagedn=getImage(getDocumentBase(),getParameter("helpImagedn"));
      myTracker.addImage(buttonCanvas.helpImagedn,tracked++);

      buttonCanvas.logoImage=getImage(getDocumentBase(),getParameter("logoImage"));
      myTracker.addImage(buttonCanvas.logoImage,tracked++);
    }

    if (getParameter("backgroundlogo")!=null)
    {
      myDisplay.backgroundImage=getImage(getDocumentBase(),getParameter("backgroundlogo"));
      myTracker.addImage(myDisplay.backgroundImage,tracked++);
    }

    for(r=0; r<tracked; r++)
    {
      try { myTracker.waitForID(r); }
      catch (Exception e) { System.out.println("Error: "+e.toString()); }
    }

    if (getParameter("defaultencoding")!=null)
    { encodingString=getParameter("defaultencoding"); }
      else
    { encodingString="ASCII"; }

    if (getParameter("bottombar")!=null)
    {
      if (!getParameter("bottombar").equals("0"))
      add("South",SouthPanel);
    }
      else
    { add("South",SouthPanel); }

    if (getParameter("channelbox")!=null)
    {
      if (getParameter("channelbox").equals("0")) channelbar=0;
    }

    if (getParameter("namebox")!=null)
    {
      if (getParameter("namebox").equals("0")) namebar=0;
    }

    if (channelbar==1 || namebar==1)
    { add("North",NorthPanel); }

    if (rightbar==1) 
    { 
      r=buttonCanvas.logoImage.getWidth(this);
      if (r<buttonCanvas.helpImage.getWidth(this))
      { r=buttonCanvas.helpImage.getWidth(this); }
      if (r<buttonCanvas.channelImage.getWidth(this))
      { r=buttonCanvas.channelImage.getWidth(this); }
      if (r<buttonCanvas.whoImage.getWidth(this))
      { r=buttonCanvas.whoImage.getWidth(this); }

      if (getParameter("userlist")!=null)
      if (getParameter("userlist").equals("1")) 
      {
        userList=new List();
        EastPanel.add(userList);
        userList.setSize(r,100);

        userList.setLocation(4,buttonCanvas.logoImage.getHeight(this)+8);
      }

      EastPanel.add(buttonCanvas);
      buttonCanvas.setSize(r+6,2);
      EastPanel.setSize(r+6,CenterPanel.getSize().height);

      add("East",EastPanel); 
    }

    add("Center",CenterPanel);

    if (getParameter("allowanychannel")!=null)
    {
      if (getParameter("allowanychannel").equals("0") 
	|| getParameter("allowanychannel").toLowerCase().equals("false")) 
      { allowanychannel=0; }
    }

    if (getParameter("fontsize")!=null)
    { myDisplay.fontsize=Integer.parseInt(getParameter("fontsize")); }
      else
    { myDisplay.fontsize=13; }

    if (getParameter("font")!=null)
    { myDisplay.font=getParameter("font"); }
      else
    { myDisplay.font="Dialog"; }

    myDisplay.setup();
    gg=myDisplay.getGraphics();

    if (userList!=null) myDisplay.userList=userList;

    if (getParameter("hebrew")!=null)
    { if (getParameter("hebrew").equals("1")) myDisplay.hebrew=1; } 
      else
    if (getParameter("arabic")!=null)
    { if (getParameter("arabic").equals("1")) myDisplay.hebrew=1; } 

    privateFrame=new Frame("Send Private Message");
    privateFrame.hide();
    privateFrame.setSize(400,200);
    privatePanel=new Panel();
    privateButtonPanel=new Panel();
    privatePanel.setLayout(new GridLayout(3,1));
    privateButtonPanel.setLayout(new GridLayout(1,2));
    privateLabel=new Label("Send Private Message To:");
    privateText=new TextField("hi");
    privateSendButton=new Button("Send");
    privateCancelButton=new Button("Cancel");
    privatePanel.add(privateLabel);
    privatePanel.add(privateText);
    privateButtonPanel.add(privateSendButton);
    privateButtonPanel.add(privateCancelButton);
    privatePanel.add(privateButtonPanel);
    privatePanel.setBackground(panelColor);
    privatePanel.setForeground(panelforeColor);
    privateFrame.add(privatePanel);

    privateSendButton.addActionListener(this);
    privateCancelButton.addActionListener(this);
    messageText.addActionListener(this);
    if (userList!=null) userList.addActionListener(this);
    myDisplay.myApplet=this;
  }

  public void start()
  {
  int l,w,h,o;

    if (rightbar==1)
    {
      w=EastPanel.getSize().width;
      h=EastPanel.getSize().height;
      o=CenterPanel.getSize().width;
      buttonCanvas.setSize(w,h);

      buttonCanvas.logoImageX=(w/2)-(buttonCanvas.logoImage.getWidth(this)/2);
      buttonCanvas.logoImageY=5;

      h=h-buttonCanvas.helpImage.getHeight(null)-4;
      buttonCanvas.helpImageX=(w/2)-(buttonCanvas.helpImage.getWidth(this)/2);
      buttonCanvas.helpImageY=h;

      h=h-buttonCanvas.channelImage.getHeight(null)-4;
      buttonCanvas.channelImageX=(w/2)-(buttonCanvas.channelImage.getWidth(this)/2);
      buttonCanvas.channelImageY=h;

      h=h-buttonCanvas.whoImage.getHeight(this)-4;
      buttonCanvas.whoImageX=(w/2)-buttonCanvas.whoImage.getWidth(this)/2;
      buttonCanvas.whoImageY=h;
    }

    if (rightbar==1)
    if (userList!=null)
    {
      userList.setSize(buttonCanvas.getSize().width-8,
        EastPanel.getSize().height-
        buttonCanvas.helpImage.getHeight(this)-
        buttonCanvas.logoImage.getHeight(this)-
        buttonCanvas.channelImage.getHeight(this)-
        buttonCanvas.whoImage.getHeight(this)-22);
    }

    myThread=new Thread(this);
    myThread.start();
  }

  public int logon()
  {
    try 
    {
      if (getParameter("host")==null)
      { host=getCodeBase().getHost(); }
	else
      { host=getParameter("host"); }

      if (getParameter("port")==null)
      { mySocket=new Socket(host,6666); }
	else
      { mySocket=new Socket(host,Integer.parseInt(getParameter("port"))); }

      myInputStream=mySocket.getInputStream(); 
      myBuffInput=new BufferedInputStream(myInputStream,2048);
      myOutputStream=mySocket.getOutputStream(); 
      Online=1;

    }
    catch (Exception e) { Online=0; }

    if (Online==1) return 0;

    return 1;
  }

  public void run()
  {
  byte[] in=new byte[2048];
  int r,t,k,c=0;
  String myString="";
  String inString="";

    myDisplay.AddText(">> Logging into server...",0);
    if (logon()!=0)
    {
      myDisplay.AddText(">> Couldn't not log into server.  Server is down or a firewall is blocking you.",0);
      Online=0;
    }

    if (Online==1)
    { 
      if (getParameter("username")!=null)
      {
        if (nameText!=null)
        { nameText.setText(getParameter("username")); }

        YourName=getParameter("username").trim();
        if (YourName.length()!=0)
        {
          myString=".n"+YourName;
          if (getParameter("password")!=null)
          {
            if (getParameter("password").trim().length()!=0)
            { myString=myString+"="+getParameter("password").trim(); }
          }
          myString=myString+"\n\r";
        }

        if (getParameter("defaultchannel")!=null)
        {
          myString=myString+".c"+getParameter("defaultchannel").trim()+"\n\r";
/*
          try 
          { sendtext(".c"+getParameter("defaultchannel")); }
          catch (Exception e) {}
*/
          if (channelbar!=0) channelText.setText(getParameter("defaultchannel"));
        }
      }

      if (userList!=null)
      { myString=myString+".Z"; }

      try { sendtext(myString); }
      catch (Exception e) { }
      myString="";
    }

    while(true)
    {
      if (Online==1)
      {
        try { c=myBuffInput.read(in,0,2048); }
        catch (Exception e)
	{ System.out.println("Error: "+e.toString()); Online=0; }

        if (c<=0)
        {
          Online=0; 
          /* System.out.println("Death "+c); */
          continue;
        }

        try { inString=new String(in,0,c,encodingString); }
        catch (Exception e) { System.out.println("Error: "+e.toString()); }

        for(r=0; r<c; r++)
        {
          if (in[r]!='\n' && in[r]!='\r') 
          {
	    myString+=""+inString.charAt(r);
	  }
            else
          {
	    if (myString.length()>0)

            if (myString.trim().startsWith("*"))
            {
              myString=myString.trim().substring(1);
              if (myString.startsWith("http://"))
              {
                try { getAppletContext().showDocument(new URL(myString),"new window"); }
                catch (Exception e) { System.out.println("Error: "+e.toString()); }
              }
            }
              else
            {
              if ((k=myDisplay.AddText(myString,loggedin))!=0)
              { myDisplay.repaint(); }
              /* { myDisplay.paint(gg); } */
              if (k==2) loggedin=1;
            }

    	    if (r+1<c && (in[r+1]=='\r' || in[r+1]=='\n')) r++;
            myString="";
          }
        } 
      }
        else
      if (Online==-1)
      {
        loggedin=1;
	logon();
      }
	else
      {
         loggedin=0;
	 myDisplay.AddText(">> Connection closed by foreign host.",loggedin);
         /* myDisplay.paint(gg); */
         myDisplay.repaint();

         try { mySocket.close(); }
	 catch (Exception e) { System.out.println("Socket: "+e.toString()); } 
         break;
      }      
    }
  }

  public void actionPerformed(ActionEvent e)
  {
  String obj;
  String message;

    try 
    {
      if (e.getSource()==channelText && allowanychannel==1)
      { 
        sendtext(".c "+channelText.getText());
        if (channelText.getText().equals("0")) channelText.setText("Main");
          else
        if (channelText.getText().equals("main")) channelText.setText("Main");
          else
        if (channelText.getText().equals("1"))
            channelText.setText("Masquerade");
          else
        if (channelText.getText().equals("masquerade"))
            channelText.setText("Masquerade");
      }
        else
      if (e.getSource()==messageText)
      { 
        message=messageText.getText();

        if (message.startsWith(".n"))
        { 
          if (namebar==1)
          { nameText.setText(message.substring(2)); }
        }
          else
        if (message.startsWith(".c") && allowanychannel==0)
	{
	  message="..";
	}
          else
        if (message.startsWith(".b"))
	{
	  myDisplay.AddText(">> Applet sound disabled.",loggedin);
	}

        sendtext(message);
        messageText.setText("");
      }
        else
      if (e.getSource()==nameText)
      { 
        if (!nameText.getText().equals(YourName))
          sendtext(".n"+nameText.getText());
        YourName=nameText.getText();
      }
        else
      if (e.getSource()==userList)
      {
        privateFrame.show();
        privateText.setText("");
        privateLabel.setText("Send Private Message To: "+userList.getSelectedItem());
      }
        else
      if (e.getSource()==privateSendButton || e.getSource()==privateText)
      {
        message=privateLabel.getText();
        message=message.substring(message.indexOf("[")+1,
                                  message.indexOf("]"));
        message=".p"+message+" "+privateText.getText();
        sendtext(message);
        privateFrame.hide();
      }
        else
      if (e.getSource()==privateCancelButton)
      {
        privateFrame.hide();
      }
    }
    catch (Exception ex) { System.out.println("Problem: "+ex.toString()); }
  }

  public void itemStateChanged(ItemEvent e)
  {
    try
    {
      if (e.getSource()==chanChoice)
      {
        if (chanChoice.getSelectedIndex()!=0)
        {
          sendtext(".c"+chanChoice.getSelectedItem()); 
          channelText.setText(chanChoice.getSelectedItem());
          chanChoice.select(0);
        }
      }
    }
    catch (Exception ex) { System.out.println("Problem: "+ex.toString()); }
  }

  public void sendtext(String myString)
  {
    try
    {
      myOutputStream.write(convb(myString+"\n"),0,myString.length()+1);
    }
    catch (Exception e) { System.out.println("Error: "+e.toString()); }
  }

  byte[] convb(String myString)
  {
  byte[] myBytes=new byte[2048];
  int r;
  
    try
    { myBytes=myString.getBytes(encodingString); }
    catch (Exception e) { System.out.println("Error: "+e.toString()); }

    return myBytes;
  } 

  public void stop()
  {
    privateFrame.dispose();
    try { mySocket.close(); } catch (Exception e) {}
  }
}






