import java.awt.*;
import java.applet.*;
import java.lang.*;
import java.awt.event.*;

class ButtonCanvas extends Canvas implements MouseListener,MouseMotionListener
{
Image helpImage,channelImage,logoImage,whoImage;
Image helpImagedn,channelImagedn,logoImagedn,whoImagedn;
int helpImageX,helpImageY,channelImageX,channelImageY,logoImageX,logoImageY;
int whoImageX,whoImageY;
byte helpImageS=0,channelImageS=0,whoImageS=0;
DisplayArea myDisplay;
Graphics gg;
nakenchatapplet mainApplet;

  public ButtonCanvas(DisplayArea myDisplay, nakenchatapplet mainApplet)
  {  
    addMouseListener(this);
    addMouseMotionListener(this);
    this.myDisplay=myDisplay;
    this.mainApplet=mainApplet;
    gg=this.getGraphics();
  }

  public void paint(Graphics gg)
  {
  Graphics ggButtons;

    ggButtons=this.getGraphics();
    ggButtons.drawImage(logoImage,logoImageX,logoImageY,null);

    if (whoImageS==0)
    { ggButtons.drawImage(whoImage,whoImageX,whoImageY,null); }
      else
    { ggButtons.drawImage(whoImagedn,whoImageX,whoImageY,null); }

    if (channelImageS==0)
    { ggButtons.drawImage(channelImage,channelImageX,channelImageY,null); }
      else
    { ggButtons.drawImage(channelImagedn,channelImageX,channelImageY,null); }

    if (helpImageS==0)
    { ggButtons.drawImage(helpImage,helpImageX,helpImageY,null); }
      else
    { ggButtons.drawImage(helpImagedn,helpImageX,helpImageY,null); }
  }

  public void mousePressed(MouseEvent evt) 
  {
  int x,y;

    x=evt.getX();
    y=evt.getY();

    if ((x>helpImageX && x<helpImageX+helpImage.getWidth(this)) &&
       (y>helpImageY && y<helpImageY+helpImage.getHeight(this)))
    {
      helpImageS=1;
      repaint();
    }
      else
    if ((x>whoImageX && x<whoImageX+whoImage.getWidth(this)) &&
       (y>whoImageY && y<whoImageY+whoImage.getHeight(this)))
    {
      whoImageS=1;
      repaint();
    }
      else
    if ((x>channelImageX && x<channelImageX+channelImage.getWidth(this)) &&
       (y>channelImageY && y<channelImageY+channelImage.getHeight(this)))
    {
      channelImageS=1;
      repaint();
    }
  }

  public void mouseReleased(MouseEvent evt)
  {
  int x,y;

    x=evt.getX();
    y=evt.getY();

    if (whoImageS!=0)
    {
      whoImageS=0;
      mainApplet.sendtext(".w");
      paint(gg);
    }
      else
    if (helpImageS!=0)
    {
      helpImageS=0;
      mainApplet.sendtext(".he");
      paint(gg);
    }
      else
    if (channelImageS!=0)
    {
      channelImageS=0;
      mainApplet.sendtext(".a");
      paint(gg);
    }
  }

  public void mouseDragged(MouseEvent evt) { }
  public void mouseEntered(MouseEvent evt) {}
  public void mouseExited(MouseEvent evt) {}
  public void mouseClicked(MouseEvent evt) {}
  public void mouseMoved(MouseEvent evt) {}

  public void update(Graphics gg)
  {
    paint(gg);
  }

}


